<?php
// +-----------------------------------------------------------------------------+
// | smilies for Geeklog                                                         |
// | Date: Nov, 2007                                                             |
// +-----------------------------------------------------------------------------+
// | admin/index.php                                                             |
// +-----------------------------------------------------------------------------+
// | Copyright (C) 2007 by:                                                      |
// | smilies Plugin Author:                                                      |
// | Alford Deeley - ajdeeley@summitpages.ca                                     |
// +-----------------------------------------------------------------------------+
// | Geeklog Common Code                                                         |
// | Copyright (C) 2000-2007 by the following authors:                           |
// | Authors: Tony Bibbs        - tony@tonybibbs.com                             |
// |          Mark Limburg      - mlimburg@users.sourceforge.net                 |
// |          Jason Whittenburg - jwhitten@securitygeeks.com                     |
// |          Dirk Haun         - dirk@haun-online.de                            |
// +-----------------------------------------------------------------------------+
// |                                                                             |
// | This program is licensed under the terms of the GNU General Public License  |
// | as published by the Free Software Foundation; either version 2              |
// | of the License, or (at your option) any later version.                      |
// |                                                                             |
// | This program is distributed in the hope that it will be useful,             |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of              |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        |
// | See the GNU General Public License for more details.                        |
// |                                                                             |
// | You should have received a copy of the GNU General Public License           |
// | along with this program; if not, write to the Free Software Foundation,     |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             |
// |                                                                             |
// +-----------------------------------------------------------------------------+

require_once('../../../lib-common.php');

if (!function_exists('plugin_chkVersion_smilies')){
    //just refresh page to index
    print COM_refresh($_CONF['site_url']);
    exit;
}

if (!SEC_hasRights('smilies.admin')) {
    $display = COM_siteHeader ('menu', $LANG_SMILIES00[4]);
    $display .= COM_startBlock ($LANG_SMILIES00[4], '',
                        COM_getBlockTemplate ('_msg_block', 'header'));
    $display .= $LANG_SMILIES00[5];
    $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
    $display .= COM_siteFooter ();
    COM_accessLog ("An anonymous user, {$_SERVER['REMOTE_ADDR']}, tried to illegally access the smilies admin index page.");
    echo $display;
    exit;
}

#function smilies_list_smilies(){
#    global $_CONF, $_TABLES, $_IMAGE_TYPE, $LANG_SMILIES01, $LANG_ADMIN;
#    require_once( $_CONF['path_system'] . 'lib-admin.php' );
#    
#    $retval = '';
#    
#    $header_arr = array(      # dislay 'text' and use table field 'field'
#                    #array('text' => $LANG_SMILIES01[5], 'field' => 'edit', 'sort' => false),
#                    array('text' => $LANG_SMILIES01[6], 'field' => 'filename', 'sort' => false),
#                    array('text' => $LANG_SMILIES01[7], 'field' => 'id', 'sort' => true),
#                    array('text' => $LANG_SMILIES01[8], 'field' => 'code', 'sort' => true),
#                    array('text' => $LANG_SMILIES01[9], 'field' => 'description', 'sort' => true),
#                    array('text' => $LANG_SMILIES01[10], 'field' => 'enabled', 'sort' => true)
#    );
#    
#    $defsort_arr = array('field' => 'id', 'direction' => 'ASC');
#    
#    $menu_arr = array (
#                    array('url' => $_CONF['site_url'] . '/smilies/index.php?op=new',
#                          'text' => $LANG_SMILIES01[11]),
#                    array('url' => $_CONF['site_admin_url'] . '/plugins/smilies/index.php?op=editall',
#                          'text' => $LANG_SMILIES01[13]),
#                    array('url' => $_CONF['site_admin_url'] . '/plugins/smilies/index.php?mode=config',
#                          'text' => $LANG_SMILIES01[12]),
#                    array('url' => $_CONF['site_admin_url'],
#                          'text' => $LANG_ADMIN['admin_home'])
#    );
#    
#    $text_arr = array('has_menu'     => true,
#                      'has_extras'   => true,
#                      'title'        => $LANG_SMILIES01[14],
#                      'instructions' => $LANG_SMILIES01[15],
#                      'icon'         => $_CONF['site_url'] . '/smilies/images/smilies.' . $_IMAGE_TYPE,
#                      'form_url'     => $_CONF['site_admin_url'] . "/plugins/smilies/index.php",
#                      'help_url'     => ''
#    );
#    
#    $sql = "SELECT id, filename, code, description, owner_id, enabled FROM {$_TABLES['smilies_data']}";
#
#    $query_arr = array('table' => 'users',
#                       'sql' => $sql,
#                       'query_fields' => array('id', 'filename', 'code', 'description', 'owner_id', 'enabled')
#    );
#
#    $retval .= ADMIN_list ("smilies", "plugin_getListField_smilies", $header_arr, $text_arr,
#                            $query_arr, $menu_arr, $defsort_arr);
#    return $retval;
#
#}

function smilies_editall($is_submission = false){
    global $_CONF, $_TABLES, $LANG_SMILIES03;
    
    $t = new Template($_CONF['path'] . 'plugins/smilies/templates/');
    $t->set_file('editall', 'editall.thtml');

    if ($is_submission) {
        $result = DB_query("SELECT * FROM {$_TABLES['smilies_submissions']} ORDER BY description");
        
        $blocktitle = $LANG_SMILIES03[16];
        $scanlink = '';
        $addlink = '';
        $configlink = '';
        $usemsg = $LANG_SMILIES03[17];
    } else {
        $result = DB_query("SELECT * FROM {$_TABLES['smilies_data']} ORDER BY description");
        
        $blocktitle = $LANG_SMILIES03[1];
        $scanlink = '<a href="' . $_CONF['site_admin_url'] . '/plugins/smilies/index.php?op=scandir">'
            . $LANG_SMILIES03[13] . '</a>';
        $scanlink = sprintf($LANG_SMILIES03[12],$scanlink);
        $addlink = '<a href="' . $_CONF['site_url'] . '/smilies/index.php?op=new">'
            . $LANG_SMILIES03[14] . '</a>';
        $configlink = '<a href="' . $_CONF['site_admin_url'] . '/plugins/smilies/index.php?op=config">'
            . $LANG_SMILIES03[20] . '</a>';
        $submission_count = plugin_submissioncount_smilies();
        if ($submission_count >= 1) {
            $queuelink = '<a href="' . $_CONF['site_admin_url'] . '/plugins/smilies/index.php?op=editsubmission">'
                . $LANG_SMILIES03[21] . '</a> (' . $submission_count . ')';
        } else $queuelink = '';
        $usemsg = $LANG_SMILIES03[2];
    }
    
    
    $t->set_var(array(
        'start_block' => COM_startBlock($blocktitle),
        'end_block' => COM_endBlock(),
        'use_msg' => $usemsg,
        'scan_link' => $scanlink,
        'add_link' => $addlink,
        'config_link' => $configlink,
        'queue_link' => $queuelink
        ));
    
    $count = DB_numRows($result);
    if ($count >= 1) {
        $t->set_file(array(
            'table' => 'editall_table.thtml',
            'row' => 'editall_row.thtml',
            'saverow' => 'editall_save.thtml',
            'app_cell' => 'approve_cell.thtml',
            'appheading' => 'approve_heading.thtml'
            ));
        $t->set_var(array(
            'action' => $_CONF['site_admin_url'] . '/plugins/smilies/index.php?op=editall',
            'img_heading' => $LANG_SMILIES03[5],
            'code_heading' => $LANG_SMILIES03[6],
            'desc_heading' => $LANG_SMILIES03[7],
            'enab_heading' => $LANG_SMILIES03[8],
            'del_heading' => $LANG_SMILIES03[9],
            'update' => $LANG_SMILIES03[10],
            'reset' => $LANG_SMILIES03[11],
            'cancel' => $LANG_SMILIES03[18],
            ));
        
        if ($is_submission) {
            $t->set_var(array(
                'colspan' => '6',
                'app_heading' => $LANG_SMILIES03[19]
                ));
            $t->parse('approve_heading', 'appheading');
        } else {
            $t->set_var(array(
                'colspan' => '5',
                'app_heading' => ''
                ));
        }
        
        $i = 0;
        while($A = DB_fetchArray($result)) {
            $A['id'] = COM_stripslashes($A['id']);
            $A['description'] = COM_stripslashes($A['description']);
            $A['code'] = COM_stripslashes($A['code']);
            if ($is_submission) {
                $dir = $_CONF['site_url'] . '/smilies/submissions/';
            } else {
                $dir = $_CONF['site_url'] . '/smilies/smileyfiles/';
            }
            $src = $dir . COM_stripslashes($A['filename']);
            $cssid = ($cssid ==1) ? 2: 1;
            
            $t->set_var(array(
                'id' => $A['id'],
                'src' => $src,
                'alt' => $A['filename'],
                'title' => $A['description'],
                'code' => $A['code'],
                'desc' => $A['description'],
                'cssid' => $cssid
                ));
            if ($A['enabled'] == '1') {
                $t->set_var('checked', ' checked="checked"');
            }
            if ($is_submission) {
                $t->parse('approve_cell', 'app_cell');
            }
            $t->parse('smiley_item','row',true);
            $i++;
            if ($i == $count && $count < 10) {
                $t->parse('smiley_item','saverow',true);
            }
            if (($i % 10) == 0) {
                $t->parse('smiley_item','saverow',true);
            }
            if ($i == $count && ($i % 10) > 3) {
                $t->parse('smiley_item','saverow',true);
            }
            $t->clear_var('checked');
        }
        $t->parse('smilies_table','table');
    } else {
        $t->set_var('empty_listmsg', $LANG_SMILIES03[3]);
    }
    
    $t->parse ('output','editall');
    $retval = $t->finish($t->get_var('output'));
    
    return $retval;
}

#function smilies_status_change($id){
#    global $_TABLES;
#    
#    if (DB_getItem($_TABLES['smilies_data'],"enabled", "id = '$id'")) {
#        DB_query("UPDATE {$_TABLES['smilies_data']} set enabled = '0' WHERE id = '$id' LIMIT 1");
#        return;
#    } else {
#        DB_query("UPDATE {$_TABLES['smilies_data']} set enabled = '1' WHERE id = '$id' LIMIT 1");
#        return;
#    }
#}

function smilies_delete($id){
    global $_CONF, $_TABLES;
    //called from editall, editone, admin list
    
    //get filename
    $filename = DB_getItem($_TABLES['smilies_data'], 'filename', " id = '$id'");
    //delete file from disk
    $file = $_CONF['path_html'] . 'smilies/smileyfiles/' . $filename;
    if (@unlink($file)) {
        //delete data from db
        DB_query("DELETE FROM {$_TABLES['smilies_data']} WHERE id = '$id' LIMIT 1");
        
        return true;
    } else {
        COM_errorLog("Attempt to delete smiley file, $filename, from disk failed.",1);
        return false;
    }
}

if (!function_exists('scandir')) {
    function scandir() {
        global $_CONF;
        //get an array of filenames from the dir
        $dir = $_CONF['path_html'] . 'smilies/smileyfiles/';
        if (is_dir($dir)) {
            if ($dh = opendir($dir)) {
                $files = array();
                while (($file = readdir($dh)) !== false) {
                    $files[] = $file;
                }
                closedir($dh);
            }
        }
    }
}

function smilies_scandir(){
    global $_CONF, $_USER, $_TABLES, $CONF_smilies;
    
    //get current filenames from db
    $result = DB_query("SElECT filename FROM {$_TABLES['smilies_data']}");
    if (DB_numRows($result) >= 1 ) {
        $db_files = array(); 
        while ($A = DB_fetchArray($result)) {
            $db_files[] = COM_stripslashes($A['filename']);
        }
    }
    
    //scan dir for smilies
    $dir = $_CONF['path_html'] . 'smilies/smileyfiles/';
    $files = scandir($dir);
    
    //print_r($files);
    //exit;
    
    //loop thru files
    foreach ($files as $file) {
        if ($file != "." && $file != ".." && $file != '.svn') {
            
            //check if file is in db already
            if ((!empty($db_files) && !in_array($file, $db_files)) || empty($db_files)) {
                
                //check if file ext is allowed
                $ext = substr($file, -3);
                if (in_array($ext, $CONF_smilies['allowed_ext'])) {
                    
                    // check for image size and report in error log if image exceeds allowed dimensions
                    list ($width, $height) = getimagesize($dir . $file);
                    if ($width > $CONF_smilies['max_w'] || $height > $CONF_smilies['max_h']) {
                        $error++;
                        COM_errorLog("Smiley file, $file, exceeds max height and/or width set for smilies in config.php.",1);
                    } else {
                        // Put check here for new filename to ensure no duplicates.
                        // The previous new name was added to the db_files array
                        // after the last insert - see below.
                        do {
                            $file_id = COM_makesid();
                            $filename = $file_id . '.' . $ext;
                        } while (!empty($db_files) && in_array($filename, $db_files));
                        
                        //rename file
                        $newname = $dir . $filename;
                        $oldname = $dir . $file;
                        rename($oldname, $newname);
                        
                        //insert new file data into db
                        //the smiley code will have to be added from the editor
                        //and the smiley is not enabled until its code exists.
                        $description = addslashes(substr($file, 0, -4));
                        $filename = addslashes($file_id . '.' . $ext);
                        DB_query("INSERT INTO {$_TABLES['smilies_data']} SET
                            id = '$file_id', filename = '$filename', description = '$description',
                            owner_id = '{$_USER['uid']}', enabled = '0'
                            ");
                        
                        //add new filename to db_array here for checking on next loop
                        $db_files[] = $filename;
                    }
                }
            }
        }
    }
    
    if ($error >= 1) {
        $msg = '6';
    } else {
        $msg = '3';
    }
    
    return COM_refresh($_CONF['site_admin_url'] . '/plugins/smilies/index.php?op=editall&msg=' . $msg);
}

function smilies_update_all_smilies($A){
    global $_CONF, $_TABLES, $LANG_SMILIES03;
    //called from editall or editone
    
    //return print_r($A);
    foreach ($A['id'] as $value) {
        $value = COM_applyFilter($value, true);
        
        if (!empty($value)) {
            if ($A['delete'][$value] != '1') {
                
                //update existing smiley
                $A['code'][$value] = addslashes (strip_tags (COM_checkWords ($A['code'][$value])));
                $A['desc'][$value] = addslashes (strip_tags (COM_checkWords ($A['desc'][$value])));
                if (!empty($A['code'][$value])) {
                    if ($A['enabled'][$value] != '1') {
                        $A['enabled'][$value] = '0';
                    }
                } else {
                    //no code results in a disabled smiley  :(
                    $A['enabled'][$value] = '0';
                }
                if ($A['approve'][$value] != '1') {
                    smilies_update_single_smiley($value, $A['code'][$value], $A['desc'][$value], $A['enabled'][$value]);
                } else {
                    //move from queue to approved files
                    $A = DB_query("SELECT filename, owner_id FROM {$_TABLES['smilies_submissions']} WHERE id = '$value'");
                    list($filename,$uid) = DB_fetchArray($A);
                    $filename = COM_stripslashes($filename);
                    
                    $oldname = $_CONF['path_html'] . 'smilies/submissions/' . $filename;
                    $newname = $_CONF['path_html'] . 'smilies/smileyfiles/' . $filename;
                    if (!rename($oldname, $newname)) {
                        COM_errorLog("Attempt to move smiley file, $filename, from submissions directory failed.",1);
                        $error = true;
                    } else {
                        smilies_exit_queue($value, $filename, $A['code'][$value], $A['desc'][$value], $uid, $A['enabled'][$value]);
                    }
                }
            } else {
                //delete existing smilie
                if (!smilies_delete($value)) {
                    $error = true;
                }
            }
        }
    }
    
    if ($error) {
        $msg = '5';
    } else {
        $msg = '4';
    }
    
    $return_page = $_CONF['site_admin_url'] . '/plugins/smilies/index.php?op=editall&msg=' . $msg;
    return COM_refresh($return_page);
}

function smilies_exit_queue($id, $filename, $code, $description, $uid, $enabled){
    global $_TABLES;
        
    DB_query("INSERT INTO {$_TABLES['smilies_data']} SET id = '$id',
        filename = '$filename', code = '$code', description = '$description',
        owner_id = '$uid', enabled = '$enabled'");
    DB_query("DELETE FROM {$_TABLES['smilies_submissions']} WHERE id = '$id' LIMIT 1");
}

function smilies_update_single_smiley($id, $code, $description, $enabled){
    global $_TABLES;
    DB_query("UPDATE IGNORE {$_TABLES['smilies_data']} SET code = '$code',
        description = '$description', enabled = '$enabled'
        WHERE id = '$id'");
}

function smilies_display_config(){
    global $_CONF, $_TABLES, $LANG_SMILIES01, $LANG_SMILIES03;
    
    $result = DB_query("SELECT * FROM {$_TABLES['smilies_settings']}");
    $S = DB_fetchArray($result);
    
    $t = new Template($_CONF['path'] . 'plugins/smilies/templates/');
    $t->set_file('config', 'config.thtml');
    
    $scanlink = '<a href="' . $_CONF['site_admin_url'] . '/plugins/smilies/index.php?op=scandir">'
        . $LANG_SMILIES03[13] . '</a>';
    $scanlink = sprintf($LANG_SMILIES03[12],$scanlink);
    $addlink = '<a href="' . $_CONF['site_url'] . '/smilies/index.php?op=new">'
        . $LANG_SMILIES01[28] . '</a>';
    $managelink = '<a href="' . $_CONF['site_admin_url'] . '/plugins/smilies/index.php?op=editall">'
        . $LANG_SMILIES01[27] . '</a>';
    $submission_count = plugin_submissioncount_smilies();
    if ($submission_count >= 1) {
        $queuelink = '<a href="' . $_CONF['site_admin_url'] . '/plugins/smilies/index.php?op=editsubmission">'
            . $LANG_SMILIES01[26] . '</a> (' . $submission_count . ')';
    } else $queuelink = '';
    
    $checked = array();
    $checked[0] = '';
    $checked[1] = ' checked = "checked"';
    $blocktitle = $LANG_SMILIES01[25];
    
    $t->set_var(array(
        'scan_link' => $scanlink,
        'add_link' => $addlink,
        'queue_link' => $queuelink,
        'manage_link' => $managelink,
        'start_block' => COM_startBlock($blocktitle),
        'end_block' => COM_endBlock(),
        'action' => $_CONF['site_admin_url'] . '/plugins/smilies/index.php?op=config',
        'legend' => $LANG_SMILIES01[16],
        'useradd_label' => $LANG_SMILIES01[17],
        'queue_label' => $LANG_SMILIES01[18],
        'maxw_label' => $LANG_SMILIES01[19],
        'maxh_label' => $LANG_SMILIES01[20],
        'not_label' => $LANG_SMILIES01[22],
        'auto_label' => $LANG_SMILIES01[21],
        'ua_checked' => $checked[$S['enabled_useradd']],
        'qu_checked' => $checked[$S['enabled_queue']],
        'not_checked' => $checked[$S['enabled_notification']],
        'au_checked' => $checked[$S['disabled_autotags']],
        'max_w' => $S['max_w'],
        'max_h' => $S['max_h'],
        'save' => $LANG_SMILIES01[1],
        'reset' => $LANG_SMILIES01[3],
        'cancel' => $LANG_SMILIES01[2],
        'sub_note' => $LANG_SMILIES01[23],
        'auto_note' => $LANG_SMILIES01[24]
        ));
    
    $t->parse('output','config');
    $retval = $t->finish($t->get_var('output'));
    
    return $retval;
}

function smilies_save_settings($S){
    global $_CONF, $_TABLES;
    
    $S['useradd'] = ($S['useradd'] != '1') ? '0' : '1';
    $S['queue'] = ($S['queue'] != '1') ? '0' : '1';
    $S['notification'] = ($S['notification'] != '1') ? '0' : '1';
    $S['maxw'] = COM_applyFilter($S['maxw'],true);
    $S['maxw'] = (empty($S['maxw'])) ? '30' : $S['maxw'];
    $S['maxh'] = COM_applyFilter($S['maxh'],true);
    $S['maxh'] = (empty($S['maxh'])) ? '30' : $S['maxh'];
    $S['autotags'] = ($S['autotags'] != '1') ? '0' : '1';
    
    DB_query("UPDATE {$_TABLES['smilies_settings']} SET
        enabled_useradd = '{$S['useradd']}',
        enabled_queue = '{$S['queue']}',
        enabled_notification = '{$S['notification']}',
        max_w = '{$S['maxw']}', max_h = '{$S['maxh']}',
        disabled_autotags = '{$S['autotags']}'
        ");
    
    return COM_refresh($_CONF['site_admin_url'] . '/plugins/smilies/index.php?op=config&msg=4');
}

/*
 main
*/

if (isset($_REQUEST['msg'])){
    $msg = COM_applyFilter($_REQUEST['msg'], true);
} else $msg = '';

if (isset ($_REQUEST['mode'])) {
    $op = COM_applyFilter($_REQUEST['mode']);
} elseif (isset($_REQUEST['op'])) {
    $op = COM_applyFilter($_REQUEST['op']);
} else $mode = '';

if (isset ($_REQUEST['id'])) {
    $id = COM_sanitizeID($_REQUEST['id'],false);
} else $id = '';

#if (isset ($_REQUEST['statusChange'])) {
#    smilies_status_change(COM_sanitizeID($_REQUEST['statusChange'],false));
#}

if ($mode == 'editsubmission') {
    print COM_refresh($_CONF['site_url'] . '/smilies/index.php?op=editsubmission');
    exit;
}

$display = COM_siteHeader();

if (!empty($msg)) {
    //msg block
    $display .= COM_startBlock($LANG_SMILIES04[2],'','blockheader-message.thtml');
    $display .= $LANG_SMILIES04[$msg];
    $display .= COM_endBlock('blockfooter-message.thtml');
}

if ($op == 'config') {
    if ($_POST['submit'] == $LANG_SMILIES01[1]) { //save settings
        print smilies_save_settings($_POST);
        exit;
    } elseif ($_POST['submit'] == $LANG_SMILIES01[2]) { //cancel
        print COM_refresh($_CONF['site_url'] . '/smilies/index.php?op=list');
        exit;
    #} elseif ($_POST['submit'] == $LANG_SMILIES01[4]) { //apply defaults
    #    print smilies_apply_defaults();
    #    exit;
    } else { //display config editor
        $display .= smilies_display_config();
    }
} elseif ($op == 'scandir' && SEC_inGroup('Root')) {
    print smilies_scandir();
    exit;
} elseif ($op == 'editsubmission') {
    $display .= smilies_editall(true);
} elseif ($op == 'editall') {
    if (isset($_POST['submit']) && $_POST['submit'] == $LANG_SMILIES03[10]) {
        print smilies_update_all_smilies($_POST);
        exit;
    } else {
        $display .= smilies_editall();
    }
} else {
    $display .= smilies_editall();
}

$display .= COM_siteFooter();

echo $display;

?>