<?php
// +-----------------------------------------------------------------------------+
// | smilies for Geeklog                                                         |
// | Date: Nov, 2007                                                             |
// +-----------------------------------------------------------------------------+
// | english.php plugin specific language arrays                                 |
// +-----------------------------------------------------------------------------+
// | Copyright (C) 2007 by:                                                      |
// | smilies Plugin Author:                                                      |
// | Alford Deeley - ajdeeley@summitpages.ca                                     |
// +-----------------------------------------------------------------------------+
// | Geeklog Common Code                                                         |
// | Copyright (C) 2000-2007 by the following authors:                           |
// | Authors: Tony Bibbs        - tony@tonybibbs.com                             |
// |          Mark Limburg      - mlimburg@users.sourceforge.net                 |
// |          Jason Whittenburg - jwhitten@securitygeeks.com                     |
// |          Dirk Haun         - dirk@haun-online.de                            |
// +-----------------------------------------------------------------------------+
// |                                                                             |
// | This program is licensed under the terms of the GNU General Public License  |
// | as published by the Free Software Foundation; either version 2              |
// | of the License, or (at your option) any later version.                      |
// |                                                                             |
// | This program is distributed in the hope that it will be useful,             |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of              |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        |
// | See the GNU General Public License for more details.                        |
// |                                                                             |
// | You should have received a copy of the GNU General Public License           |
// | along with this program; if not, write to the Free Software Foundation,     |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             |
// |                                                                             |
// +-----------------------------------------------------------------------------+

/* gl integrations:  links, stats, search, etc. */
$LANG_SMILIES00 = array (
    1   => 'smilies',
    2   => 'Smilies',
    3   => 'Add Smiley',
    4   => 'Access Denied',
    5   => 'Only Authorized Users have Access to this Page.  Your IP has been recorded.',
    6   => 'Smiley Submissions',
    7   => 'Smiley',
    8   => 'Code',
    9   => 'Description',
    10  => 'Contributer',
    11  => 'The following smiley has been submitted to the smilies queue and awaits your approval:',
    12  => 'Filename:',
    13  => 'Code:',
    14  => 'Description:',
    15  => 'Empty',
    16  => 'Smiley Submission Notification',
    17  => 'Submissions',
    18  => 'End of message'
);

/* admin */
$LANG_SMILIES01 = array (
    1   => 'Save',
    2   => 'Cancel',
    3   => 'Reset',
    4   => 'Apply Defaults',
    5   => 'Edit',
    6   => 'Smiley',
    7   => 'ID',
    8   => 'Code',
    9   => 'Description',
    10  => 'Enabled?',
    11  => 'Add New Smiley',
    12  => 'Config Options',
    13  => 'Edit All',
    14  => 'Smilies Manager',
    15  => 'To add a new smiley, click on "Add New Smiley" above.<br />To manage global options, click on "Smilies Config" above.<br />To modify or delete smilies, click on the "Edit All" link above to perform bulk editing.<br />To enable/disable a smiley, check the appropriate box below.',
    16  => 'Options',
    17  => 'Allow logged in users to add smilies?',
    18  => 'Enable the submissions queue for logged in users?',
    19  => 'Maximum width for uploaded smilies',
    20  => 'Maximum height for uploaded smilies',
    21  => 'Disable smiley autotags?',
    22  => 'Enable email notification for submitted smilies?',
    23  => 'If not checked, submissions from users will pass directly to the approved smilies list.',
    24  => 'You would check this if you wanted to disable smilies globally without having to disable or delete the plugin.',
    25  => 'Smilies Configuration Editor',
    26  => 'Manage submissions',
    27  => 'Smilies manager',
    28  => 'Add new smiley'
);

/* list */
$LANG_SMILIES02 = array (
    1   => 'There are currently no smilies available.',
    2   => '%s to add a smiley.',
    3   => 'Click here',
    4   => 'Available Smilies',
    5   => 'Smiley Image',
    6   => 'Code',
    7   => 'Description',
    8   => 'Adding smilies to site content that supports autotags is as easy as typing <strong>[smiley: <i>code</i>]</strong> where <i>code</i> can be found in the table below.<br />For example, I could type <strong>[smiley: :)]</strong> in order see this: %s.',
    9   => '%s for more smilies.',
    10  => 'Scan disk',
    11  => 'Edit All Smilies'
);

/* editor */
$LANG_SMILIES03 = array (
    1   => 'Smilies Manager',
    2   => 'Any smiley without a code will be disabled.',
    3   => 'There are currently no smilies available for editing.',
    4   => '',
    5   => 'Smiley Image',
    6   => 'Code',
    7   => 'Description',
    8   => 'Enabled?',
    9   => 'Delete?',
    10  => 'Update',
    11  => 'Reset',
    12  => '%s for more smilies.',
    13  => 'Scan disk',
    14  => 'Add new smiley',
    15  => 'Click here',
    16  => 'Manage Smiley Submissions',
    17  => 'All submissions will remain in the queue until approved.  Any smiley without a code will remain disabled.',
    18  => 'Cancel',
    19  => 'Approve?',
    20  => 'Configuration options',
    21  => 'Manage submissions'
);

/* add form */
$LANG_SMILIES05 = array(
    1   => 'Add New Smilies',
    2   => 'Add your smilies, their code, and a brief description below.',
    3   => 'Submit',
    4   => '',
    5   => 'Smiley Image',
    6   => 'Code',
    7   => 'Description',
    8   => 'Enabled?',
    9   => 'Submit',
    10  => 'Reset'
);

/* messages */
$LANG_SMILIES04 = array (
    1   => "The smilies storage directory, {$_CONF['path_html']}smilies/smileyfiles/, is currently not writable.  Please adjust your permissions.",
    2   => 'Alert!',
    3   => 'Any valid files found have been added to the database and may now be edited. You will have to add the smiley\'s code and enable the smiley from the editor.',
    4   => 'Valid updates have been applied.',
    5   => 'Valid updates have been applied.<br />Errors occured while updating your smilies.  See error.log for more info.',
    6   => 'Any valid files found have been added to the database and may now be edited. You will have to add the smiley\'s code and enable the smiley from the editor.<br />Errors occurred while adding your smilies.  See error.log for more info.',
    7   => 'Valid files have been added to the database and will now appear in the following list if enabled.',
    8   => 'Valid files have been added to the database and will now appear in the following list if enabled.<br />Errors occured while adding new smilies.  See error.log for more info.',
    9   => "Thank-you for your submission to {$_CONF['site_name']}. Valid files have been submitted to our staff for approval. If approved, your smilies will be available for use on our site.",
    10  => 'Valid files have been added to the database and will now appear in the following list if enabled.<br />At least one error has occured while adding new smilies--Contact the site admin for more info.' 
);

/* sort options */
$LANG_SMILIES06 = array (
    1   => '',
    2   => '',
    3   => '',
    4   => ''
);

?>